/*
 * Created on Jun 7, 2005
 *
 * TOOODO JL: implement JFC Test for ProblemBrowser
 */
package isac.functest.problems;

import javax.swing.JDialog;
import javax.swing.JMenuItem;
import javax.swing.JPanel;

import junit.extensions.jfcunit.JFCTestCase;
import junit.extensions.jfcunit.JFCTestHelper;
import junit.extensions.jfcunit.eventdata.MouseEventData;
import junit.extensions.jfcunit.finder.ComponentFinder;
import junit.extensions.jfcunit.finder.NamedComponentFinder;
import isac.gui.WindowApplication;
import isac.interfaces.IToUser;
import isac.util.interfaces.MockToUser;

/**
 * JFCTestProblemHierarchy
 * 
 * All JFC unit tests for the ProblemBrowser
 * 
 * @author JL
 * @version $Revision$
 *  
 */
public class JFCTestProblemHierarchy extends JFCTestCase {
    private WindowApplication window_application_;

    private IToUser to_user_mock_;

    public JFCTestProblemHierarchy(String name) {
        super(name);
    }

    protected void setUp() throws Exception {
        super.setUp();
//        setHelper(new JFCTestHelper());
//        window_application_ = new WindowApplication();
//        to_user_mock_ = new MockToUser();
        //windowsApplication.addListener
    }

    protected void tearDown() throws Exception {
//        window_application_.dispose();
//        window_application_ = null;
//        JFCTestHelper.cleanUp(this);
        super.tearDown();
    }

    //login in the application if not already logged in
    protected void login() {
        ComponentFinder finder = new ComponentFinder(Object.class);
        //JDialog loginDialog = (JDialog) finder.find(window_application_, 0);
       // assertNotNull("login should exist", loginDialog);
/*
        if (loginDialog.isVisible()) {
            assertFalse("windowApplication should not be visible",
                    window_application_.isVisible());
            //find login button
            finder = new NamedComponentFinder(JButton.class, "Login");
            JButton loginButton = (JButton) finder.find(loginDialog, 0);

            //find username field an enter valid username
            finder = new NamedComponentFinder(JTextField.class, "UserName");
            JTextField userNameTextField = (JTextField) finder.find(
                    loginDialog, 0);
            getHelper().sendString(
                    new StringEventData(this, userNameTextField, "user"));

            //find password field an enter valid password
            finder = new NamedComponentFinder(JPasswordField.class, "Password");
            JPasswordField passwordField = (JPasswordField) finder.find(
                    loginDialog, 0);
            getHelper().sendString(
                    new StringEventData(this, passwordField, "user"));

            //click on login button
            getHelper().enterClickAndLeave(
                    new MouseEventData(this, loginButton));
            assertTrue("windowApplication should now be visible",
                    window_application_.isVisible());
        } else { // already loged in
            assertTrue("windowApplication should be visible", window_application_
                    .isVisible());
        }
        */
    }

    /**
     * {\bf\UC{User browses through the knowledge
     * hierarchies}\label{UC:problemhierarchy}\\} \label{userbrowse} A student
     * uses a WEB-Browser to gain an overview of \sisac s problem hierarchy, for
     * instance, see p.\pageref{3D-math}.
     * 
     * TOOODO implement
     * 
     * @author JL
     * 
     * @see isac.gui.TestWindowApplicationJFCUnit#testOpenProblemBrowser for hints how the
     *      browser is lauched
     * 
     * @see isac.kestore.TestKEStoreServices#testLoadPage() for how an XML-file
     *      of an example or a problem is fetched
     * 
     * @see isac.util.users.TestUser#testGetUserSettings() for how to provide
     *      for settings to guide the filtering of explanations
     * 
     * @version $Revision$
     */
    /*
     public void testOverviewOfProblems() {
        System.out
                .println("---BEGIN isac.functest.TestProblemHierarchy#testOverviewProblems");
        System.out.println("TODO");
        assertEquals("TODO", "TODO");
        System.out
                .println("---END isac.functest.TestProblemHierarchy#testOverviewProblems");
    }
    */
    
    /**
     * {\bf\UC{Toggle a problem from instantiated to
     * non-instantiated}\label{UC:match-toggle-no}\\} The problem browser has
     * been called from a worksheet, and shows the problem instantiated from the
     * worksheet's context. A toggle-button switches to the plain problem
     * without instantiation. And vice versa.
     * 
     * WN050618 diesen UC bitte an JL uebergeben (gehoert dort vermutlich zu
     * isac.functest.problems.TestProblemHierarchy
     */
    public void testToggleProblemInstantiation() {
        System.out
                .println("---BEGIN isac.functest.JFCTestProblemHierarchy#testToggleProblemInstantiation");
        System.out.println("TODO");
        assertEquals("TODO", "TODO");
        System.out
                .println("---END isac.functest.JFCTestProblemHierarchy#testToggleProblemInstantiation");
    }

    /**
     * Tests if the correct problem browser is opened if more worksheeds are open
     * 
     * @author JL
     * @TOOODO JL: implement
     */
/*
    public void testCallProblemBrowserFromWorksheed() {
    	System.out.println("---BEGIN isac.functest.TestProblemHierarchie#testCallProblemBrowserFromWorksheet");


    	login();
        //see if there is a menuItem 'NewWorksheet'
        NamedComponentFinder finder = new NamedComponentFinder(JMenuItem.class,
                "ExampleBrowser");
        JMenuItem example_browser_button = (JMenuItem) finder.find(
                window_application_, 0);
        assertNotNull("Could not find the ExampleBrowser button",
                example_browser_button);
        
        getHelper().enterClickAndLeave(new MouseEventData(this,
                	example_browser_button));
        finder = new NamedComponentFinder(JPanel.class, "ExampleBrowser");
        JPanel exampleBrowserPanel = (JPanel) finder.find(window_application_, 0);
        assertNotNull("exampleBrowser should exist", exampleBrowserPanel);
        assertTrue("exampleBrowser should be visible", !exampleBrowserPanel
                .isVisible());


        //click on 'new worksheet' twice
//        getHelper().enterClickAndLeave(
//                new MouseEventData(this, new_worksheet_button));
//        getHelper().enterClickAndLeave(
//                new MouseEventData(this, new_worksheet_button));
//
//        //test if an empty worksheet apears
//        finder = new NamedComponentFinder(JPanel.class, "Worksheet");
//        JPanel worksheetPanel = (JPanel) finder.find(windowApplication, 0);
//        assertNotNull("worksheet should exist", worksheetPanel);
//        assertTrue("worksheet should be visible", worksheetPanel.isVisible());
    	
    	System.out.println("---END isac.functest.TestProblemHierarchie#testCallProblemBrowserFromWorksheet");
    }
*/
    public void testAvoidWarning() {//WN050708
    }

}