package isac.session;

import isac.users.IUserManager;
import isac.users.User;

import java.rmi.Naming;

import junit.framework.TestCase;

public class TestSessionManager extends TestCase {
  
  
  
  public void testSessionManager() {
    try {
      String name = "//localhost/isac-ObjectManager";
      Object lookup = Naming.lookup(name);
      IUserManager user_manager = ((IObjectManager) lookup)
          .getUserManager();
      
      Session session = (Session)user_manager.login("x", "x");
      
      
      ISessionManager sessionManager = SessionManager.getInstance();
      User user = user_manager.getUser(session.getId());
      sessionManager.addSession(user);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
  

}
